# SoAntiSquish Class Reference
[Nodes]

`#include <Inventor/nodes/SoAntiSquish.h>`

Inheritance diagram for SoAntiSquish:

List of all members.

## Detailed Description

The SoAntiSquish class is used to reset to uniform scaling.

When traversed, this node replaces the scale vector of the matrix with uniform values, based on one of the SoAntiSquish::Sizing strategies.

This node is for instance used by manipulators to retain the shape of their dragger geometries when set up within the influence of an SoSurroundScale node (which can yield nonuniform scale-vectors in the current state transformation matrix).

See also:
  SoSurroundScale for a usage example.

## Public Types

enum | Sizing { X, Y, Z, AVERAGE_DIMENSION, BIGGEST_DIMENSION, SMALLEST_DIMENSION, LONGEST_DIAGONAL }

## Public Member Functions

| SoAntiSquish (void)
void | recalc (void)
virtual void | doAction (SoAction *action)

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoSFEnum | sizing
SoSFBool | recalcAlways

## Protected Member Functions

virtual | ~SoAntiSquish ()
virtual void | callback (SoCallbackAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | pick (SoPickAction *action)
SbMatrix | getUnsquishingMatrix (const SbMatrix &squishedmatrix, const SbBool calcinverse, SbMatrix &getinverse)

## Member Enumeration Documentation

enum SoAntiSquish::Sizing

| Different strategies for "unsquishing" a scale. Values are used by the SoAntiSquish::sizing field.

## Constructor & Destructor Documentation

SoAntiSquish::SoAntiSquish | ( | void |  | ) |

| Constructor.

SoAntiSquish::~SoAntiSquish | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoAntiSquish::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoTransformation.

void SoAntiSquish::recalc | ( | void |  | ) |

If SoAntiSquish::recalcAlways has been set to `FALSE`, you must call this method whenever the transformations before this node in the graph has changed.

See also:
  SoAntiSquish::recalcAlways

void SoAntiSquish::doAction | ( | SoAction * | action | ) | `[virtual]`

| Accumulates an "unsquishing" matrix on top of the current model matrix. Reimplemented from SoNode.

void SoAntiSquish::callback | ( | SoCallbackAction * | action | ) | `[protected, virtual]`

| Action method for SoCallbackAction. Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph. Reimplemented from SoNode.

void SoAntiSquish::GLRender | ( | SoGLRenderAction * | action | ) | `[protected, virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoNode.

void SoAntiSquish::getBoundingBox | ( | SoGetBoundingBoxAction * | action | ) | `[protected, virtual]`

Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculates their bounding box also overrides this method to change the relevant state variables.

Reimplemented from SoNode.

void SoAntiSquish::getMatrix | ( | SoGetMatrixAction * | action | ) | `[protected, virtual]`

| Action method for SoGetMatrixAction. Updates action by accumulating with the transformation matrix of this node (if any). Reimplemented from SoNode.

void SoAntiSquish::pick | ( | SoPickAction * | action | ) | `[protected, virtual]`

| Action method for SoPickAction. Does common processing for SoPickAction action instances. Reimplemented from SoNode.

SbMatrix SoAntiSquish::getUnsquishingMatrix | ( | const SbMatrix & | squishedmatrix,
|  | const SbBool | calcinverse,
|  | SbMatrix & | getinverse
| ) | `[protected]`

| Calculate and return the matrix needed to "unsquish" the squishedmatrix. If calcinverse is `TRUE`, store the inverse of the unsquishmatrix in getinverse.

## Member Data Documentation

SoSFEnum SoAntiSquish::sizing

| The current "unsquish" strategy. Default value is SoAntiSquish::AVERAGE_DIMENSION.

SoSFBool SoAntiSquish::recalcAlways

| Whether to automatically have the unsquishing parameters recalculated for every traversal. Default value is `TRUE`. You can set this to `FALSE` and manually invoke SoAntiSquish::recalc() if you need closer control of the geometry influenced by this node.

The documentation for this class was generated from the following files:

- SoAntiSquish.h
- SoAntiSquish.cpp